#! /bin/sh
# Kevin Moore's SYN output interface failure mode (2.3.32).

# Need job control.
set -m

# Match outgoing to tap0.
../packet-filter/userspace/iptables -P OUTPUT DROP
../packet-filter/userspace/iptables -A OUTPUT -o tap1 -j ACCEPT || exit 1

../tools/rcv_ip 10 1 < /dev/tap1 > $TMPFILE &
sleep 1

# Only TCP calls the buggy code, so need `real tcp'.
telnet $TAP1NET.2 &

if wait %../tools/rcv_ip; then :
else
    echo ../tools/rcv_ip failed:
    cat $TMPFILE
    exit 1
fi

if grep -q "^$TAP1 $TAP1NET.2 [0-9]* 6 [0-9]* 23 SYN " < $TMPFILE
then :
else
    echo rcv_ip not like: "$TAP1 $TAP1NET.2 [0-9]* 6 [0-9]* 23 SYN":
    cat $TMPFILE
    exit 1
fi

kill %telnet

exit 0
