#! /bin/sh -x

# Script to test NAT of fragments (Thorsten Knabe's bug).

# Need job control.
set -m

../NAT/userspace/ipnatctl -I -s $TAP0NET.2 -d $TAP1NET.2 -b source -t $TAP0NET.3 || exit 1

../tools/rcv_ip 3 2 < /dev/tap1 > $TMPFILE &
sleep 1

../tools/gen_ip FRAG=0,1480 MF $TAP0NET.2 $TAP1NET.2 2000 17 1 2 > /dev/tap0 || exit 1
../tools/gen_ip FRAG=1480,500 $TAP0NET.2 $TAP1NET.2 2000 17 1 2 > /dev/tap0 || exit 1

if wait %../tools/rcv_ip; then :
else
    echo wait failed
    cat $TMPFILE
    exit 1
fi

# We expect a series of forward fragments.
if [ "`cat $TMPFILE`" != "MF $TAP0NET.3 $TAP1NET.2 1500 17 1 2 
FRAG=1480 $TAP0NET.3 $TAP1NET.2 520 17 " ]
then
    echo "Unexpected fragments: "
    cat $TMPFILE
    exit 1
fi

exit 0
